function CV=LH_tStat_CV(X,hh)
K=5000
T=rows(X);
N=cols(X);
tstat=zeros(cols(X)+1,cols(hh),K);
tstat_Valkanov=tstat;
for k=1:K
randn('seed',sum(100*clock));
r=randn(rows(X),1);

%make r,X orthogonal
r_orth_reg=newols(r,[X,ones(length(X),1)]);
r=r_orth_reg.u;

r=cumsum(r);
%LHaux=LHReg(r,X,hh);
%for l=1:cols(hh);
%    dr{l}=r-lag0(r,hh(l));dr{l}=dr{l}(hh(l)+1:T,:);
%    u{l}=dr{l}-X(1:T-hh(l),:)*LHaux.b(1:N,l)-LHaux.b(N+1,l);
%    LH_hh=nwest(u{l},[X(1:T-hh(l),:),ones(T-hh(l),1)],hh(l)+1);
%    tstat(k,l)=LH_hh.tstat(1,1);
%end;

%Reg.u




LHreg_k=LHreg(r,X,hh);
tstat(:,:,k)=LHreg_k.t(:,:);
tstat_Valkanov(:,:,k)=tstat(:,:,k)./[ones(rows(tstat),1)*sqrt(T-hh)];
end;



figure(1)
tstat2hist=vec(tstat(1,6,:));

histfit(tstat2hist);
figure(2)
tstat2hist=vec(tstat_Valkanov(1,6,:));
histfit(tstat2hist);

tstat=abs(tstat);
tstat_Valkanov=abs(tstat_Valkanov);

tstat=sort(tstat,3);
tstat_Valkanov=sort(tstat_Valkanov,3);

CV.t=tstat(:,:,0.95*K);
CV.t_Valkanov=tstat_Valkanov(:,:,0.95*K);
