EquityHoldings=xlsread('FinancialAssetOwnershipByOwnerType.xls');


EquityHoldings=EquityHoldings(5:end,2:end);
EquityHoldings_SampleRange=[1,EquityHoldings(1,1);4,EquityHoldings(1,end)+1];


TotalHoldings=EquityHoldings(5,:)';

HouseHoldHoldings=EquityHoldings(6,:)';

ForeignHoldings=EquityHoldings(9,:)';


PensionFundHoldings=EquityHoldings(13:16,:);%includes life insurance, private pension funds, state, local and federal pension funds
PensionFundHoldings=sum(PensionFundHoldings)';


PensionFundShare=PensionFundHoldings./TotalHoldings;
HouseHoldShare= HouseHoldHoldings./TotalHoldings;
ForeignShare= ForeignHoldings./TotalHoldings;


%extend till end of 2010 by replicating last observation
ForeignShare=[ForeignShare;ForeignShare(end,1)];    
HouseHoldShare=[HouseHoldShare;HouseHoldShare(end,1)];
PensionFundShare=[PensionFundShare;PensionFundShare(end,1)];

%make it quarterly

ForeignShareQ=kron(ForeignShare,ones(4,1));
HouseHoldShareQ=kron(HouseHoldShare,ones(4,1));
PensionFundShareQ=kron(PensionFundShare,ones(4,1));

%ForeignShareQ=adjrange(ForeignShareQ,EquityHoldings_SampleRange,XploreRange,4);
%HouseHoldShareQ=adjrange(HouseHoldShareQ,EquityHoldings_SampleRange,XploreRange,4);
%PensionFundShareQ=adjrange(PensionFundShareQ,EquityHoldings_SampleRange,XploreRange,4);

PensionFundShareQ=PensionFundShareQ;%./(1-ForeignShareQ);

PF_expandedQ=[zeros(20,1);PensionFundShareQ;0]; %add dummies for 1947:1-1951:4

