%Do the out-of sample test for cpy
modelnum=7
clear Z1*
T0=50;%offset in subsamples
T0=80;%offset in full sample
T1=T;
MSPE_1=zeros(1,modelnum);MSPE_2=MSPE_1;
FC_r=zeros(T,modelnum);
FC_u=FC_r;
dEx=[ExRetCRSP(1,:);diff(ExRetCRSP)];
WinSize=40;
ReEstimateCIVector=1;
WhichNonNestedTest='DMW';%WhichNonNestedTest='MDM'


clear e1 e2 OoSTest* model_nested
for k=1:modelnum;
  
for t=T0:T1-1
    
    %re-estimate cpy and cay
    
    if ReEstimateCIVector==1;
        
        joh_t=new_joh_proc(Y(1:t,:),[],L,h,0,0);

        cpy_reg_fc=newols(Y(1:t,1),[Y(1:t,2:3),ones(t,1)]);   
        %cpy_reg_fc=DOLS(Y(1:t,1),Y(1:t,2:3),[],0);   
        %cpy_reestimated_t(1:t,1)=[Y(1:t,:)]*[1;-cpy_reg_fc.b(1:2,1)];
        cpy_reestimated_t(1:t,1)=[Y(1:t,:)]*[joh_t.beta/joh_t.beta(1,1)];
        
        cpy_tilde=[cpy_reestimated_t(1:t,:)];
        
        %cpy_tilde=[Y(1:t,:)];
        
        joh_t=new_joh_proc([LL.cons(1:t,1),LL.assets(1:t,1),LL.human(1:t,1)],[],L,h,0,0);
        cay_reg_fc=newols(LL.cons(1:t,1),[LL.assets(1:t,1),LL.human(1:t,1),ones(t,1)]);  
        %cay_reg_fc=DOLS(LL.cons(1:t,1),[LL.assets(1:t,1),LL.human(1:t,1)],[],0);  
        %cay_reestimated_t(1:t,1)=[[LL.cons(1:t,1),LL.assets(1:t,1),LL.human(1:t,1)]]*[1;-cay_reg_fc.b(1:2,1)];    
        cay_reestimated_t(1:t,1)=[[LL.cons(1:t,1),LL.assets(1:t,1),LL.human(1:t,1)]]*[joh_t.beta/joh_t.beta(1,1)];;    
        
        cay_tilde=[cay_reestimated_t(1:t,:)];
        
        %cpy_tilde=cay_tilde;   %run all models below with cay re-estimated
                                %instead of cpy
        
    else
        cpy_tilde=cpy; 
        %cpy_tilde=[cpy,cpy.*PartRate];
        
        
        cay_tilde=cay;
    end;
    
    k2=size(cpy_tilde,2);
    
    const=ones(t,1);
        
    model_nested=0;
   
    switch k
        
        % cases 1&2 are nested comparisons as in LL 2001.
        case 1 %constant 
            Z_1{k}=[const];
            Z_2{k}=[cpy_tilde(1:t,1),Z_1{k}];
            model_nested=1;
        
        case 2 %AR of lagged returns
            Z_1{k}=[dEx(1:t,:),const];
            Z_2{k}=[cpy_tilde(1:t,1),Z_1{k}];
            model_nested=1;
                
        
            
       %following cases are non-nested tests
        
        case 3 %lagged excess returns
            Z_1{k}=[dEx(1:t,:),const];
            Z_2{k}=[cpy_tilde(1:t,1),const];
            
        
        case 4;%dividend price ratio
            Z_1{k}=[d_p(1:t,:),const];
            Z_2{k}=[cpy_tilde(1:t,:),const];
            
        case 5 %dividend earnings ratio
            Z_1{k}=[d_e(1:t,:),const];
            Z_2{k}=[cpy_tilde(1:t,:),const];   
        
        case 6 %Aaa-Baa spread
            Z_1{k}=[ BaaAaaSpreadQ(1:t,1),const];
            Z_2{k}=[cpy_tilde(1:t,:),const];
        
        case 7 %re-estimated cay   
            Z_1{k}=[cay_tilde(1:t,1),const];
            Z_2{k}=[cpy_tilde(1:t,:),const];  
       
       
            
%         case 8 %re-estimated cay   
%             Z_1{k}=[cay_tilde(1:t,1),const];
%             Z_2{k}=[cpy_tilde(1:t,:),Z_1{k}];
%             model_nested=1; 
        
        end;
        

        
    %StepReg=LHReg(dEx(1:t-1,:),Z1{k}(1:t-1,:),1);
    StepReg_2=newols(dEx(2:t,:),Z_2{k}(1:t-1,:));
    StepReg_1=newols(dEx(2:t,:),Z_1{k}(1:t-1,:));
    
    FC_1(t+1,k)=[Z_1{k}(t,:)]*StepReg_1.b;
    FC_2(t+1,k)=[Z_2{k}(t,:)]*StepReg_2.b;
    
    
    e1(t+1-T0,k)=dEx(t+1,:)-FC_1(t+1,k);
    e2(t+1-T0,k)=dEx(t+1,:)-FC_2(t+1,k);
    
    
    MSPE_1(1,k)=MSPE_1(1,k)+(dEx(t+1,:)-FC_1(t+1,k))^2;
    MSPE_2(1,k)=MSPE_2(1,k)+(dEx(t+1,:)-FC_2(t+1,k))^2;
    
end;%t
%RMSPE_r(1,k)=sqrt(RMSPE(1,k)/(T-T0));


MD{k}=DieboldMarianoTest(e1(:,k),e2(:,k),1);

MDM{k}=ModifiedDieboldMariano(e1(:,k),e2(:,k),1);

OoSF{k}=OoSFStatNestedModels(e1(:,k),e2(:,k),T0,3);%e1. nested model, e2 nesting (i.e. larger model)
%note that only models 1-2 are nested, stat does not make sense for the
%other models...

switch WhichNonNestedTest
    
    case 'MDM'
     OoSTest(1,k)=MDM{k}.DMmodified;
     OoSTestCV(:,k)=MDM{k}.CV(:,3:4);%95,90 percent values
 
    case 'DMW'
    OoSTest(1,k)=MD{k}; %plain vanilla Diebold-Mariano-West which is N(0,1).
    OoSTestCV(:,k)=[1.96, 1.64];
end;

if model_nested==1
    disp('nested model, adjust test')
    OoSTest(1,k)=OoSF{k}.F;
    OoSTestCV(:,k)=OoSF{k}.CV(:,2:3);%95, 90 percent values
end;    

end;%k
MSPE_1=MSPE_1/(T-T0);
MSPE_2=MSPE_2/(T-T0);



%PseudoR2=1-RMSPE./RMSPE();

disp('Table 8 for the following configuration:')
XploreRange
ReEstimateCIVector
T0
disp(['Test: ',WhichNonNestedTest]);
disp(' ');
disp('model mse/mse_a OosTest CV95%  CV90%')
disp(FormatTable([(1:modelnum);MSPE_2./MSPE_1;OoSTest;OoSTestCV]'));

%plot([dEx(T0+1:end,1),FC(T0+1:end,:)])
