function [Regressor,Regressand]=varsetup(Data,L)
%function [Regressor,Regressand]=varsetup(Data)
%This function sets up the regressors and regressands of a VAR, using
%the Data as input and T (sample size), L (Lag) and N (dimension) as
%global givens.

if nargin<2
global L
end;
    

[m,n]=size(Data);

if L>0;
Regressor=[];
for i=1:L;
Regressor=[Regressor,lag0(Data,i)];
end;%for...
end;%if...

Regressor=Regressor(L+1:m,:);


Regressand=Data(L+1:m,:);


%end function


