%StatePropInc=xlsread('ProprietaryIncome_1948Q12008Q1')
StatePropInc=xlsread('ProprietaryIncome_1948Q12011Q1');


StatePop=xlsread('population19292007');%currently no offocial state-level populationd data between 2001 and 2010.
                                        %They are being updated following
                                        %the 2010 census.


StatePop=StatePop(4:54,3:end)';
StatePropInc=StatePropInc(2:52,3:end)';

StatePop_A=StatePop;


%If XploreRange ends before 2007, go with XploreRange, otherwise cut off at 2007

ShortXploreRange=[XploreRange(:,1),min([XploreRange(:,2),[2007;2007]],[],2)];
StatePop=adjrange(StatePop,[1,1929;1,2007],[ShortXploreRange(1,:);[1,ShortXploreRange(2,2)]],1);
StatePropInc=adjrange(StatePropInc,[1,1948;1,2011],[ShortXploreRange(1,:);ShortXploreRange(2,:)],4);




    
StatePop=kron(StatePop,ones(4,1));

StatePropInc=StatePropInc./StatePop;



statepropinc=log(StatePropInc);


popWeight=StatePop./(sum(StatePop')'*ones(1,51));

USPropInc=sum([StatePropInc.*popWeight]')';


lags=8
dstatepropinc=statepropinc-lag0(statepropinc,lags);
dstatepropinc=dstatepropinc(lags+1:size(statepropinc,1),:);

dUSpropinc=log(USPropInc)-lag0(log(USPropInc),lags);
dUSpropinc=dUSpropinc(lags+1:size(USPropInc,1),:);

IdioRsk=dstatepropinc-dUSpropinc*ones(1,51);


smoothness=0
Rsk=std(IdioRsk')';


Rsk=Rsk-mean(Rsk);Rsk=Rsk./std(Rsk);

AdjXploreRange=ShortXploreRange+[mod(lags,4),floor(lags/4);0,0];
cpy_short=adjrange(cpy,XploreRange,AdjXploreRange,4);%
cpy_short=cpy_short-mean(cpy_short);cpy_short=cpy_short./std(cpy_short);



cstr=cal(AdjXploreRange(1,2),AdjXploreRange(1,1),4);


figure(3)
clf
tsplot([cpy_short,Rsk],cstr);





