function TableBody=FormatTable(TableIn,formatstring);

TableBody=[];

if nargin<2;
    formatstring='%5.2f';
end;

for r=1:size(TableIn,1);
    TableLine=[];
    for c=1:size(TableIn,2);
        switch (TableIn(r,c))
            
            case {Inf}
            string2add='';
            TableLine=[TableLine,sprintf(string2add),sprintf('\t')];
            
            case {-Inf}
            TableLine=strvcat(TableLine,' ');
            
            
            otherwise         
        
            if isnan(TableIn(r,c))==1    
                string2add=' ';
            else
                string2add=num2str(TableIn(r,c),formatstring);
            end;
            
            TableLine=[TableLine,sprintf(string2add),sprintf('\t')];
        
        end;
        
    end;
    %TableLine=[TableLine,sprintf('\n')]
    TableBody=strvcat(TableBody,TableLine);
end;

TableBody;
    