%LH_regression battery for PropInc/CPY Project


betacdy=[1,-0.2388,-0.6833]';

Ycdy=adjrange([cons,dividendinc,otherinc],SampleRange,[1,1952;4,2010],4);



cdy=Ycdy*betacdy;
cdy=adjrange(cdy,[1,1952;4,2010],XploreRange,4);


StockDataLoadUpdated_TillEnd2010
LoadShillerDataUpdated_Till2Q2011;
LL=MyUpdateLLData_Till_1Q2011(SampleRange,PCEPI,POP);

LoadBaaAaaSpread;



%
cay=LL.cay-mean(LL.cay);


assets=LL.assets-mean(LL.assets);

cay=adjrange(cay,LL.range,XploreRange,4);

assets=adjrange(assets,LL.range,XploreRange,4);







auxreg=newols(BaaAaaSpreadCycle,[cpy,ones(size(cpy,1),1)]);
res_BaaAaa=auxreg.u;

if ~exist('hh')
hh=[1,2,4,8,12,16,24];
end;

AllSuspects=[d_p,d_e,TBillCycle,BaaAaaSpreadCycle]; AllSuspectLabels={'d_p','d_e','TBill','BaaAaaSpread'};

UsualSuspects=[TBillCycle,BaaAaaSpreadCycle];%d_p,d_e,TBillCycle,


LHCRSP=LHreg(ExRetCRSP,[cpy,UsualSuspects],hh);


LHCRSPcpyonly=LHreg(ExRetCRSP,[cpy],hh);
LHCRSPcayonly=LHreg(ExRetCRSP,[cay],hh);
LHCRSPcdyonly=LHreg(ExRetCRSP,[cdy],hh);


LHCRSP_cpcy=LHreg(ExRetCRSP,[cp,cy],hh);


LHCRSPSuspectsOnly=LHreg(ExRetCRSP,[UsualSuspects],hh);

AuxReg=newols(cay,[cpy,ones(size(cpy,1),1)]);
AuxReg_cpy=newols(cpy,[UsualSuspects,ones(size(cpy,1),1)]);
LHCRSPcpycay=LHreg(ExRetCRSP,[cpy,cay,UsualSuspects],hh);
LHCRSPcpycayonly=LHreg(ExRetCRSP,[cpy,cay],hh);


LHCRSP2Stage=LHreg(ExRetCRSP,[cpy,AuxReg.u,UsualSuspects],hh);

LHCRSPcpycdyonly=LHreg(ExRetCRSP,[cpy,cdy],hh);



%%Based on S&P
LHSPcpySuspects=LHreg(ExRetSP,[cpy,UsualSuspects],hh);
LHSPcaySuspects=LHreg(ExRetSP,[cay,UsualSuspects],hh);


LHSPSuspectsOnly=LHreg(ExRetSP,[UsualSuspects],hh);
LHSPcpyonly=LHreg(ExRetSP,[cpy],hh);
LHSPcayonly=LHreg(ExRetSP,[cay],hh);
LHSPcdyonly=LHreg(ExRetSP,[cdy],hh);

LHSPSuspectsOnly=LHreg(ExRetSP,[UsualSuspects],hh);
LHSPcpycay=LHreg(ExRetSP,[cpy,cay,UsualSuspects],hh);
LHSPcpycayonly=LHreg(ExRetSP,[cpy,cay],hh);

AuxReg=newols(cay,[cpy,ones(size(cpy,1),1)]);
LHSP2Stage=LHreg(ExRetSP,[cpy,AuxReg.u,UsualSuspects],hh);
LHSPcpy2Stage=LHreg(ExRetSP,[AuxReg_cpy.u,UsualSuspects],hh);


for n=1:size(AllSuspects,2);

    LHSP2Stage_n{n}=LHreg(ExRetSP,[cpy,AuxReg.u,AllSuspects(:,n)],hh);
    LHSPcpySuspects_n{n}=LHreg(ExRetSP,[cpy,AllSuspects(:,n)],hh);
    LHSPSuspectsOnly_n{n}=LHreg(ExRetSP,[AllSuspects(:,n)],hh);

end
    




LHD=LHreg(dividends-cpi,[cpy,UsualSuspects],hh);

LHDcpyonly=LHreg(dividends-cpi,[cpy],hh);
LHDcayonly=LHreg(dividends-cpi,[cay],hh);

LHDd_ponly=LHreg(dividends-cpi,[d_p],hh);
LHDcpycay=LHreg(dividends-cpi,[cpy,cay],hh);
LHD2Stage=LHreg(dividends-cpi,[cpy,AuxReg.u],hh);

LHPcpyonly=LHreg(prices-cpi,[cpy],hh);

LHDPcpyonly=LHreg(d_p,[cpy],hh);

LHDPcayonly=LHreg(d_p,[cay],hh);


LHEarncpyonly=LHreg(earnings-cpi,[cpy],hh);
LHEdivSPcpyonly=LHreg(dividends-cpi,[cpy],hh);



LHDEcpyonly=LHreg(d_e,[cpy],hh);


LHOtherInccpyonly=LHreg(adjrange(otherinc,SampleRange,XploreRange,4),[cpy],hh);

LHLabInccpyonly=LHreg(adjrange(labinc,SampleRange,XploreRange,4),[cpy],hh);

LHDivInccpyonly=LHreg(adjrange(dividendinc,SampleRange,XploreRange,4),[cpy],hh);


LHPropInccpyonly=LHreg(adjrange(propinc,SampleRange,XploreRange,4),[cpy],hh);





%Recursive LH_regs for figure 5
window=40
offset=50;
for t=1:T-window;
    window_t=t+(1:window);
    %window_t=(1:t)'+offset
LHSP_aux=LHreg(ExRetSP(window_t,1),[cpy(window_t,1)],[1,4,8,12]);
LHSP_Rec{t}=LHSP_aux;
rec_delta(t,1)=LHSP_Rec{t}.b(1,1);
rec_delta(t,2)=LHSP_Rec{t}.b(1,2);
rec_delta(t,3)=LHSP_Rec{t}.b(1,3);
rec_delta(t,4)=LHSP_Rec{t}.b(1,4);
end;


