function DMTest=ModifiedDieboldMariano(e1,e2,h);


n=size(e1,1);
if n~=size(e2,1)
    disp('OoS period of unequal length')
    return;
end;


d=(e1-e2).*e1;

d_bar=mean(d);


Q2=0;

for tau=-(h-1):(h-1);
    Q2=Q2+[d(tau+1:end,1)-d_bar]'*[d(1:end-tau,1)-d_bar]/n;
end;


R2=d_bar*sqrt(n/Q2);


DM=R2;

MDM=sqrt([n+1-2*h+h*(h-1)/n]/n)*DM;


CV(1)=tinv(0.995,n);
CV(2)=tinv(0.975,n);
CV(3)=tinv(0.95,n);
CV(4)=tinv(0.90,n);

PVal=1-tcdf(MDM,n);


DMTest.DMconventional=DM;
DMTest.DMmodified=MDM;
DMTest.CV=CV;
DMTest.PVal=PVal;







    
    