%cd US-PropIncData

%TBill=xlsread('CRSPIndex','T-Bill Rate');%Jan 34- Feb 04;
TBill=xlsread('PropIncCPYDataUpdated','T-Bill Rate');%Jan 34- Feb 04;

%CRSP=xlsread('CRSPIndex','CRSP-Index');%Jan 26 - Dez 02;
CRSP=xlsread('PropIncCPYDataUpdated','CRSP-Index');%Jan 26 - Dez 02;
 
%cd ..

%CRSP=CRSP(:,2)%Just the value-weighted index
CRSP=CRSP(2:end,6);%Just the value-weighted index

TBill=TBill(4:end,2);%kills the first 3 rows (NaN)/headers and teh first column (date)


CRSPQ=AggLowFreq(CRSP,12,4,3);%Quarterly Stock Prices 
%TBill=TBill(1:size(TBill,1)-2,:);%Kill last two observations (to get to full year)
TBillQ=AggLowFreq(TBill,12,4,1);%Quarterly T-Bill from Q1 1934- Q4 2002, use first observation of first month in quarter
%TBillQ=TBillQ(2:size(TBillQ,1),:);%Kill first 'NaN';(required for MATLAB
%6 due to differences in the old and new xlsread functions.
%TBillQ=lag0(TBillQ,1);



for t=13:length(TBillQ);
TBillQ_MA(t,:)=mean(TBillQ(t-12:t,1));
end;


TBillQ=adjrange(TBillQ,[1,1934;4,2010],XploreRange,4);%Note: start one quarter earlier...
CRSPQ=adjrange(CRSPQ,[1,1926;4,2010],XploreRange-[1,0;0,0],4);%Have CRSPQ start one quarter earlier, so we don't loose an observation when differencing
RealTBillQ=TBillQ/400-[0;adjrange(diff(log(PCEPI)),[1,1947;1,2011],XploreRange,4)];

TBillQ=TBillQ/100;%Is expressed in percent
TBillQ=TBillQ/4;%quarterly rates. After all, stock returns are quarterly as well.
TBillCycle=TBillQ-hpfilter(TBillQ,1600);

ExRetCRSP=diff(log(CRSPQ))-lag0(TBillQ,0);%Since TBill Q is first observation of first month in quarter whereas dlog Return is from end quarter to end quarter, no lag necessary!

ExRetCRSP=cumsum(ExRetCRSP);

